import React, { useRef, useState, useEffect } from 'react';
import {
    PerspectiveCamera,
    CameraControls,
    PresentationControls,
    FlyControls,
    OrbitControls,
    FirstPersonControls,
    MapControls,
} from '@react-three/drei';
import { useThree, useFrame } from '@react-three/fiber';
import { useStore } from '@/store';

const Controls = (props) => {
    const controlsRef = useRef();
    const [choiceCtrls, setChoiceCtrls] = useState(false);
    const store = useStore();

    useEffect(() => {
        if (props.fly) {
            setChoiceCtrls(false);
        } else {
            setChoiceCtrls(true);
        }
    }, [props])

    const ctrl = () => {
        return (
            <group>
                {/* <PresentationControls /> */}
                {/* <CameraControls ref={controlsRef} /> */}
                <OrbitControls
                    ref={controlsRef}
                    autoRotate={store.autoRotate}
                    autoRotateSpeed={0.5}
                    target={[-200, 100, 0]}
                />
                {/* <PointerCtrl /> */}
            </group>
        );
    };

    const flyCtrl = () => {
        return (
            <group>
                <FirstPersonControls
                    far={100000}
                    movementSpeed={100}
                    activeLook={false}
                    lookVertical={true}
                ></FirstPersonControls>
                {/* <OrbitControls /> */}
                <MapControls zoomSpeed={0.1} />
            </group>
        );
    };

    return (
        <>
            {choiceCtrls ? ctrl() : flyCtrl()}
        </>
    );
};

export default Controls;
